
clear all;
%% Main loop
FirstVid=365;
LastVid=378;
%for k1 =0:5
for k2 = FirstVid : LastVid
%% Konstanty
MidToMid    = 0.275;  %[m]
%CropStartX  = 200;    %[pixel]
%CropStartY  = 0;    %[pixel]
%CropWidth   = 1300;    %[pixel]
%CropHeight  = 900;    %[pixel]
Coef   = 3;      %pro index, Start+ Stop-
AngCoef   = 6;      %pro index, Start+ Stop-
DeltaT      = 0.1;    %[s] (plati pro 10 fps)

%% Priprava jmena videa
%number=352;
%number = k1*50+k2;
number = k2;
numStr=num2str(number);
vidName = ['vid' numStr '.mp4'];

%% Nacteni videa a info
%obj = VideoReader('vid017.mp4')
obj = VideoReader(vidName);
%get(obj) %vice dat o souboru
%implay('vid001.mp4') %prehraje video
nframes = get(obj, 'NumberOfFrames'); %da pocet snimku ve videu

%% Zpracovani jednotlivych obrazku
mojeData=zeros(nframes,4);
i=0;

firstImage = read(obj, 1);
firstImageGray=rgb2gray(firstImage);
firstImageCrop=imcrop(firstImageGray,[350 0 950 1080]);
[firstCircles,firstRadii]= imfindcircles(firstImageCrop,[5 15],'ObjectPolarity','dark','Sensitivity',0.85);


lastImage= read(obj, nframes);
lastImageGray =rgb2gray(lastImage);
lastImageCrop =imcrop(lastImageGray,[350 0 950 1080]);
[lastCircles,lastRadii]= imfindcircles(lastImageCrop,[5 15],'ObjectPolarity','dark','Sensitivity',0.85);

CropStartX  = -50 +350+ min([firstCircles(1,1) firstCircles(2,1) lastCircles(1,1) lastCircles(2,1)]);    %[pixel]
CropStartY  = -50 + min([firstCircles(1,2) firstCircles(2,2) lastCircles(1,2) lastCircles(2,2)]);
CropWidth   =  50 +350 + max([firstCircles(1,1) firstCircles(2,1) lastCircles(1,1) lastCircles(2,1)])-CropStartX;   %[pixel]
CropHeight  = 50 + max([firstCircles(1,2) firstCircles(2,2) lastCircles(1,2) lastCircles(2,2)])-CropStartY;    %[pixel]
if CropStartX < 0 
    CropStartX = 0; 
end
if CropStartY < 0 
    CropStartY = 0;
end


for k = 1 : nframes %loop
    %nacte jednotlivy snimek
    singleFrame = read(obj, k);

    % Convert to grayscale to do morphological processing. a oriznuti
    % (nepouzivat resize, pak je kolecko moc maly
    I = rgb2gray(singleFrame);
    Ia = imcrop(I,[CropStartX CropStartY CropWidth CropHeight]);
    
    %nalezeni kruhu
    [centers, radii] = imfindcircles(Ia,[5 15],'ObjectPolarity','dark','Sensitivity',0.85);
    
    %roztrizeni na predni a zadni kruh
    if centers(1,2)>centers(2,2)
    mojeData(k,1)=centers(1,1);
    mojeData(k,2)=centers(2,1);
    mojeData(k,3)=centers(1,2);
    mojeData(k,4)=centers(2,2);
    else
    mojeData(k,1)=centers(2,1);
    mojeData(k,2)=centers(1,1);
    mojeData(k,3)=centers(2,2);
    mojeData(k,4)=centers(1,2);  
    end
    i=i+1;
end

%% Zobrazeni dat z loopu
radii1=zeros(nframes,1);% vektor polomeru pro zobrazeni
for j = 1 : nframes %loop pro naplneni
radii1(j,1)=3;
end
figure(1)
subplot(1,2,1);
imshow(Ia);
h1 = viscircles([mojeData(:,1) mojeData(:,3)],radii1,'EdgeColor','b');
h2 = viscircles([mojeData(:,2) mojeData(:,4)],radii1,'EdgeColor','r');

%% Zpracovani dat
index1=1;
angles=zeros(nframes-2,2);
distances=zeros(nframes-2,1);
MidMid=zeros(nframes-2,1);
for a = 1 : (nframes-2)
%mojeData(x1,x2,y1,y2)
x1=mojeData(a,1);
x2=mojeData(a,2);
x3=mojeData(a+2,1);
x4=mojeData(a+2,2);
y1=mojeData(a,3);
y2=mojeData(a,4);
y3=mojeData(a+2,3);
y4=mojeData(a+2,4);  

v1 = [x2,y2] - [x1,y1];
v2 = [x4,y4] - [x3,y3];
v3 = [x3,y3] - [x1,y1];
%v4 = [x4,y4] - [x3,y3];
angles(a,1) = atan2(abs(det([v1;v2])),dot(v1,v2));
angles(a,2)=(angles(a,1)*360)/(2*pi);
distances(a,1)= sqrt(v3(1,1)*v3(1,1)+v3(1,2)*v3(1,2));
MidMid(a,1)= sqrt(v1(1,1)*v1(1,1)+v1(1,2)*v1(1,2));
end


%% Vypocet okraju pohybu
startVal=max(distances(:,1))/4;
pom = 1;
while startVal>distances(pom,1)
pom = pom +1;
end
startIndex=pom;
while startVal<distances(pom,1)
    if pom >= nframes-2
    break
    end
    pom = pom +1;
    
end
stopIndex=pom-1;

%%
truePixel=zeros(stopIndex-startIndex-2*Coef+1,1);
for c=(startIndex + Coef):(stopIndex - Coef)
truePixel(c-startIndex-Coef+1,1)=MidMid(c);
end
avgPixel=mean(truePixel(:,1)); %[m/s]
pixelDim=MidToMid/avgPixel;
%% Vypocet velikosti pixelu
%pixelDim=MidToMid/(mean(MidMid(:,1)));

%% Prepocet na jednotky SI, graf
distances2=zeros(nframes-2,1);
MidMid2=zeros(nframes-2,1);
speed=zeros(nframes-2,1);
angles2=zeros(nframes-2,1);
for b = 1 : (nframes-2)
distances2(b,1)= pixelDim*distances(b,1);
MidMid2(b,1)=pixelDim*MidMid(b,1);
speed(b,1)=distances2(b,1)/DeltaT;
angles2(b,1)=angles(b,1)/DeltaT;
end
%figure(3)
subplot(1,2,2);
title('Data Bugina')
xlabel('Snimky = 0.1s')
ylabel('viz. popisky')
plot(distances2(:,1),'Color','b','LineWidth',2);
hold on;
plot(MidMid2(:,1),'Color','g','LineWidth',2);
plot(speed(:,1),'Color','m','LineWidth',2);
plot(angles2(:,1),'Color','r','LineWidth',2); 
legend('delta vzdalenosti [m]','vzdalenost dvou kruhu [m]','rychlost [m/s]','uhlova rychlost [rad/s]','Location','SouthOutside');

%% Vypocet prumerne rychlosti a uhlove rychlosti
trueSpeed=zeros(stopIndex-startIndex-2*Coef+1,1);
for c=(startIndex + Coef):(stopIndex - Coef)
trueSpeed(c-startIndex-Coef+1,1)=speed(c);
end
avgSpeed=mean(trueSpeed(:,1))/2; %[m/s]

trueAngle=zeros(stopIndex-startIndex-2*AngCoef+1,1);
for d=(startIndex + AngCoef):(stopIndex - AngCoef)
trueAngle(d-startIndex-AngCoef+1,1)=angles2(d,1);
end
avgAngle=mean(trueAngle(:,1))/2; %[rad/s]
angToDeg=avgAngle*360/(2*pi);

%% Graf puvodnich dat
%{
figure(2)
plot(angles(:,2),'Color','r');
hold on;
plot(distances(:,1),'Color','b');
plot(MidMid(:,1)/10,'Color','g');
%}

degStr=num2str(angToDeg);
angleStr=num2str(avgAngle);
speedStr=num2str(avgSpeed);
pixelStr=num2str(pixelDim);
outStr= [numStr '\t' degStr '\t' angleStr '\t' speedStr '\t' pixelStr char(10)];
fid = fopen('output.txt', 'a');
fprintf(fid, outStr);
fclose(fid);

outStrPic=['Output_' numStr '.jpg'];
saveas(1,outStrPic);
close all;
%end
end
